<template>
  <div>
    <v-card>
      <v-card-title class="light">Krijo një Llogari</v-card-title>
      <v-container>
        <v-row class="mx-2">
          <v-col cols="6">
            <v-text-field label="Kodi*" v-model="request.code" />
          </v-col>
          <v-col cols="6">
            <v-text-field label="Emri*" v-model="request.name" />
          </v-col>
          <v-col cols="6">
            <v-text-field label="Përshkrimi" v-model="request.description" />
          </v-col>
          <v-col cols="12" sm="6">
            <currency-select
              v-model="request.currency_id"
              @currency_id="getCurrencyId"
            />
          </v-col>
        </v-row>
      </v-container>
      <v-card-actions>
        <v-spacer />
        <v-btn text @click="closeModal">Anullo</v-btn>
        <f-submit-btn @click="submit" :loading="loading" :disabled="loading" />
      </v-card-actions>
    </v-card>
  </div>
</template>

<script lang="ts">
import api from '@/plugins/api'
import { Vue, Component, Prop } from 'vue-property-decorator'
import FSubmitBtn from '@/components/buttons/FSubmitBtn.vue'
import CurrencySelect from '@/components/general/CurrencySelect.vue'

@Component({
  components: { FSubmitBtn, CurrencySelect },
})
export default class AccountsTree extends Vue {
  @Prop({ default: 0 }) accountId!: number
  dialog = ''
  loading = false
  request: any = {
    parent_id: this.accountId,
    code: '',
    name: '',
    description: '',
    currency_id: '',
  }

  closeModal() {
    this.request.code = ''
    this.request.name = ''
    this.request.description = ''
    this.request.currency_id = ''
    this.$emit('close', 'create_account')
  }

  getCurrencyId(id) {
    this.request.currency_id = id
  }

  submit() {
    this.loading = true
    api()
      .post('/api/account-management/accounts', this.request)
      .then((response: any) => {
        alert(response.data.message)
        if (!response && !response.data && response.data.status !== 0) {
          return
        }
        this.closeModal()
      })
      .catch(error => {
        console.log(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }
}
</script>
